Files
linux-cryptodev-2.6/tools/perf/tests/shell/test_bpf_metadata.sh
James Clark 2f5d370dec perf test: Change all remaining #!/bin/sh to #!/bin/bash
There are 43 instances of posix shell tests and 35 instances of bash. To
give us a single consistent language for testing in, replace
all #!/bin/sh to #!/bin/bash. Common sources that are included in both
different shells will now work as expected. And we no longer have to fix
up bashisms that appear to work when someone's system has sh symlinked
to bash, but don't work on other systems that have both shells
installed.

Although we could have chosen sh, it's not backwards compatible so it
wouldn't be possible to bulk convert without re-writing the existing
bash tests.

Choosing bash also gives us some nicer features including 'local'
variable definitions and regexes in if statements that are already
widely used in the tests.

It's not expected that there are any users with only sh available due to
the large number of bash tests that exist.

Discussed in relation to running shellcheck here:
https://lore.kernel.org/linux-perf-users/e3751a74be34bbf3781c4644f518702a7270220b.1749785642.git.collin.funk1@gmail.com/

Signed-off-by: James Clark <james.clark@linaro.org>
Reviewed-by: Collin Funk <collin.funk1@gmail.com>
Acked-by: Arnaldo Carvalho de Melo <acme@redhat.com>
Link: https://lore.kernel.org/r/20250623-james-perf-bash-tests-v1-1-f572f54d4559@linaro.org
Signed-off-by: Namhyung Kim <namhyung@kernel.org>
2025-06-26 10:31:05 -07:00

77 lines
1.6 KiB
Bash
Executable File

#!/bin/bash
# SPDX-License-Identifier: GPL-2.0
#
# BPF metadata collection test.
set -e
err=0
perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
cleanup() {
rm -f "${perfdata}"
rm -f "${perfdata}".old
trap - EXIT TERM INT
}
trap_cleanup() {
cleanup
exit 1
}
trap trap_cleanup EXIT TERM INT
test_bpf_metadata() {
echo "Checking BPF metadata collection"
if ! perf check -q feature libbpf-strings ; then
echo "Basic BPF metadata test [skipping - not supported]"
err=0
return
fi
# This is a basic invocation of perf record
# that invokes the perf_sample_filter BPF program.
if ! perf record -e task-clock --filter 'ip > 0' \
-o "${perfdata}" sleep 1 2> /dev/null
then
echo "Basic BPF metadata test [Failed record]"
err=1
return
fi
# The BPF programs that ship with "perf" all have the following
# variable defined at compile time:
#
# const char bpf_metadata_perf_version[] SEC(".rodata") = <...>;
#
# This invocation looks for a PERF_RECORD_BPF_METADATA event,
# and checks that its content contains the string given by
# "perf version".
VERS=$(perf version | awk '{print $NF}')
if ! perf script --show-bpf-events -i "${perfdata}" | awk '
/PERF_RECORD_BPF_METADATA.*perf_sample_filter/ {
header = 1;
}
/^ *entry/ {
if (header) { header = 0; entry = 1; }
}
$0 !~ /^ *entry/ {
entry = 0;
}
/perf_version/ {
if (entry) print $NF;
}
' | egrep "$VERS" > /dev/null
then
echo "Basic BPF metadata test [Failed invalid output]"
err=1
return
fi
echo "Basic BPF metadata test [Success]"
}
test_bpf_metadata
cleanup
exit $err